;=================================================================
; 		M E M O R Y   M A P
;=================================================================
	ARCH_MEM_ROMBASE = 0HE000

	ARCH_MEM_TOT = 0H8000
	ARCH_MEM_INTSTACK = 0H7E00
	ARCH_MEM_BIOSREGS = 0H7D80		; be sure to amend this in linker config!
	ARCH_MEM_BIOSSTACK = 0H7D80
	ARCH_MEM_TRANS_STACK = 0H7D20

	ARCH_MEM_SIO_BUFFERS = 0H7E00
	ARCH_MEM_SIO_BUF_RX = ARCH_MEM_SIO_BUFFERS + 0H0000
	ARCH_MEM_SIO_BUF_TX = ARCH_MEM_SIO_BUFFERS + 0H0100

	ARCH_MEM_USER_TOP = 0H7000		; put this back to 7d00 later!
	ARCH_MEM_BIOS_WORK = 0H7000		; 256 bytes of workspace - used by loader etc
	FBASE = ARCH_MEM_USER_TOP

;=================================================================
; 		M E M O R Y   M A P - P A G E   Z E R O
;=================================================================
	ARCH_Z_SIO_BASE = 0H0020
	ARCH_Z_SIO_RX_HEAD = ARCH_Z_SIO_BASE + 0H01 ; next char to read from
	ARCH_Z_SIO_RX_TAIL = ARCH_Z_SIO_BASE + 0H02 ; next char to write to
	ARCH_Z_SIO_RX_FLAGS = ARCH_Z_SIO_BASE + 0H03 ; flags for receive 
			; flags are
			; 0 - dtr has been disabled

	ARCH_Z_SIO_TX_HEAD = ARCH_Z_SIO_BASE + 0H04 ; next char to read from
	ARCH_Z_SIO_TX_TAIL = ARCH_Z_SIO_BASE + 0H05 ; next char to write to
	ARCH_Z_SIO_TX_FLAGS = ARCH_Z_SIO_BASE + 0H06 ; flags for transmit

	ARCH_Z_INT_SP_SAVE = ARCH_Z_SIO_BASE + 0H08 ; save SP
	ARCH_Z_INT_HL_SAVE = ARCH_Z_SIO_BASE + 0H10 ; save SP
			
;=================================================================
; 		   I / O   A D D R E S S E S 
;=================================================================
	ARCH_IO_ROMAD = 0H0
	ARCH_IO_IOBOARDBASE = 0H20

	ARCH_IO_LCD = ARCH_IO_IOBOARDBASE + 0H00

	ARCH_IO_SIO = ARCH_IO_IOBOARDBASE + 0H04
	ARCH_IO_SIO_ADATA = ARCH_IO_SIO + 0H00
	ARCH_IO_SIO_BDATA = ARCH_IO_SIO + 0H01
	ARCH_IO_SIO_ACON = ARCH_IO_SIO + 0H02
	ARCH_IO_SIO_BCON = ARCH_IO_SIO + 0H03
