			.area	CODE2

			.include "lcd-lib.inc"
			.include "arch.inc"

			SPEED = 2 ; (in MHz)


lcd_send_nibble:
			or	#0H08		; 1.75
			out	(ARCH_IO_LCD), A; 2.75
			and	#0HF2		; 1.75
			out	(ARCH_IO_LCD), A; 2.75
			ret			; 2.5
						; total = 17.25

lcd_sendX:		push	AF
			and	#0HF0
			or	B
			call	lcd_send_nibble	; 4.25 + 17.25

			pop	AF		; 3.25
			push	AF		; 3.25
		
			sla	A
			sla	A
			sla	A
			sla	A
			or	B
			call	lcd_send_nibble ; 4.25 + 17.25

			call	lcd_pause_39us
			pop	AF
			ret

lcd_send_cmd::		; cmd to send is in A
			push	BC
			ld	B, #0H00
			call	lcd_sendX
			pop	BC
			cp	#1
			ret	NZ
			call	lcd_pause_1ms
			call	lcd_pause_1ms
			ret

lcd_send_char::		; char to send is in A
			push	BC
			ld	B, #0H02
			call	lcd_sendX
			pop	BC
			ret

lcd_pause_39us:	
			push	BC		; 3.25
			ld	B, # 1 + ((9 * SPEED) / 4); 1.75
1$:			nop			; 1
			djnz	1$		; 3.25
			pop	BC		; 3.25
			ret			; 2.5
						; total = 40

			; delay = C * ((256 * 4.25) + 4) + B * 4.25 [rough]
			; delay = C * 1064 + B * 
lcd_pause_1ms:		push	BC		; 3.25
			ld	BC,#(0H0101 + ((300 * SPEED) / 4)); 2.5
1$:			nop			; 1
			dec	C
			jr	NZ, 1$
			djnz	1$		; 3.25 2
			pop	BC		; 3.25
			ret

lcd_pause_30ms:		push	BC
			ld	B, #30
1$:			call	lcd_pause_1ms
			djnz	1$
			pop	BC
			ret

lcd_init::		push	AF

			xor	A			; clear output
			out	(ARCH_IO_LCD), A

			call	lcd_pause_30ms

			ld 	HL,#init_sequence
			ld	B, #4
1$:			ld	A, (HL)
			call	lcd_send_nibble
			call	lcd_pause_1ms
			call	lcd_pause_1ms
			inc	HL
			djnz	1$

			ld	B, #5
2$:			ld	A, (HL)
			call	lcd_send_cmd
			inc	HL
			djnz	2$

			pop	AF
			ret

init_sequence:		.db 0H30, 0H30, 0H30, 0H20
			.db 0H2C, 0H0F, 0H02, 0H06, 0H01

lcd_clear::		push	AF
			ld	A, #1
			call	lcd_send_cmd
			pop	AF
			ret

lcd_home::		push	AF
			ld	A, #1
			call	lcd_send_cmd
			pop	AF
			ret

lcd_gotoxy::		;	B.C == X,Y
			push	AF

			ld	A, B
			and	#0H3F
			bit	0, C
			jr	Z, 1$
			add	A, #0H40
1$:			or	A, #0H80
			call	lcd_send_cmd
			pop	AF
			ret

lcd_send_asciiz::	; send string at HL
			push	AF
			push	HL
1$:			ld	A, (HL)
			or	A
			jr	z, 2$
			call	lcd_send_char
			inc	HL
			jr	1$
2$:			pop	HL
			pop	AF
			ret

lcd_send_asciiz_lim::	; send string at HL
			push	AF
			push	HL
			push	BC
			ld	B, A
1$:			ld	A, (HL)
			or	A
			jr	z, 2$
			call	lcd_send_char
			inc	HL
			djnz	1$
2$:			pop	BC			
			pop	HL
			pop	AF
			ret
			