			.area	CODE2

			.include "lcd-lib.inc"
			.include "str-utils.inc"

			STRBUF=0H1000


mem_scan::		; scan through memory looking at each 2kB block test first byte
			; to see if it reads / writes if yes output '/'
			; if it reads FFH output '!'
			; if it reads something else output '?'
			; INTERRUPTS MUST BE DISABLED!

			push	HL
			push	DE
			push	BC
			push	AF

			ld	B, #0H10
			ld	HL, #0000

1$:			

			call	mem_2k

			push	BC
			push	AF
			xor	A		; zero A
			sbc	B		; subtract B
			and	#0H0F		; limit to 0..15
			ld	B, A
			ld	C, #0		; Y
			call	lcd_gotoxy
			pop	AF
			pop	BC				

			call	lcd_send_char

			ld	DE, #0H1000
			add	HL, DE

			djnz	1$

			pop	AF
			pop	BC
			pop	DE
			pop	HL

			ret

mem_2k:			push	HL
			push	DE
			push	BC

			ld	BC, #0H0010
2$:			call	mem_show_addr

1$:			ld	D, (HL)
	
			ld	A, #0
			ld	(HL), A
			ld	A, (HL)
			cp	#0
			jr	NZ, mem_bad

			ld	A, #0HFF
			ld	(HL), A
			ld	A, (HL)
			cp	#0HFF
			jr	NZ, mem_bad

			ld	A, #0HAA
			ld	(HL), A
			ld	A, (HL)
			cp	#0HAA
			jr	NZ, mem_bad

			ld	A, #0H55
			ld	(HL), A
			ld	A, (HL)
			cp	#0H55
			jr	NZ, mem_bad

			ld	(HL), D

			inc	HL

			djnz	1$
			dec	C
			jr	NZ, 2$
			
			ld	A, #"$"
			pop	BC
			pop	DE
			pop	HL
			ret

mem_bad:		pop	BC
			pop	DE
			pop	HL			
			ld	(HL), D
			ld	A, (HL)
			cp	#0HFF
			jr	NZ, mem_rom

			ld	A, #"!"
			ret

mem_rom:		ld	A, #"?"
			ret

mem_show_addr:		push	BC		; print current addr
			push	HL
			ld	BC, #0H0001
			call	lcd_gotoxy
			ld	B, H
			ld	C, L			
			ld	HL, #STRBUF
			call	str_ltoah
			call	lcd_send_asciiz
			pop	HL
			pop	BC
			ret
