			.area	CODE2

			; IX points to zero-page head/tail registers
			; returns count in A
rbuf_count::		ld	A, 0(IX)
			sub	1(IX)
			ret

			; IX points to zero-page head/tail registers
			; HL points to buffer
			; returns with Z set if buffer empty
rbuf_read::		push	HL
			ld	A, 1(IX)	; get tail
			cp	0(IX)		; get head
			jr	Z, read_out	; if the same then empty return with Z set

			add	L		; add tail pointer to HL
			ld	L, A
			jr	NC, 1$
			inc	H
1$:			inc	A		; inc tail pointer			
			di
			ld	1(IX), A	; store back
			or	H		; for Z flag off (H is always non-zero)
			ld	A, (HL)		; load buffer byte
			ei
			
read_out:		pop	HL
			ret

			; A char to write
			; IX points to zero-page head/tail registers
			; HL points to buffer
			; returns with Z set if buffer full
			; returns count remaining in A
rbuf_write::		push	HL
			push	BC
			ld	B, A
			ld	A, 0(IX)	; head pointer
			inc	A
			cp	1(IX)		; tail pointer
			jr	Z, write_outZ	; equal so full
			ld	C, A		; preserve it in C too
			dec	A		; put it back
			add	L		; add head pointer to HL
			ld	L, A
			jr	NC, 1$
			inc	H
1$:			ld	(HL), B		; store new byte
			ld	0(IX), C	; save updated pointer (has to be after store
						; or interrupts may cause problems)
			ld	A, 1(IX)	; tail pointer
			sub	C
			dec	A
			pop	BC
			pop	HL
			ret

write_outZ:		xor	A
write_out:		pop	BC
			pop	HL
			ret
			